// IOCTL calls.
// Users should use s817f.h and not call the driver directly

#ifndef S817_IOCTL_H
#define S817_IOCTL_H

#include "s817.h"

#define S817_IOCTL_OPENCHANNEL    0x2000  /* S817_OpenChannel */
#define S817_IOCTL_CLOSECHANNEL   0x2001  /* S817_CloseChannel */
/* S817_IOCTL_GETBUFFERID just gets the buffer ID.  GETBUFFER gets
   the data. */
#define S817_IOCTL_GETBUFFERID    0x2002  /* S817_GetBuffer */
#define S817_IOCTL_GETBUFFER      0x2003  /* for MMAP */
#define S817_IOCTL_RELEASEBUF     0x2004  /* S817_ReleaseBuffer */
#define S817_IOCTL_CHKBUFFER      0x2005  /* S817_ChkBuffer */
#define S817_IOCTL_SETCAPMODE     0x2006  /* S817_SetCaptureMode*/
#define S817_IOCTL_SETVIDMODE     0x2007  /* S817_SetVideoMode */
#define S817_IOCTL_SETVIDSWITCH   0x2008  /* S817_SetVideoSwitch */
#define S817_IOCTL_SETVIDOUT      0x2009  /* S817_SetVideoOut */
#define S817_IOCTL_GETEXTERRINFO  0x200a  /* S817_GetExtErrInfo */
#define S817_IOCTL_GETSTATUSINFO  0x200b  /* S817_GetStatusInfo */
#define S817_IOCTL_SETDATETIME    0x200c  /* S817_SetDateTime */
#define S817_IOCTL_SETOSDMODE     0x200d  /* S817_SetOsdMode */
#define S817_IOCTL_GETDATAMASK    0x200e
#define S817_IOCTL_ROUNDROBIN     0x200f


struct param_openchan {
	int  aChan;
	MODE mode;
};

struct param_closechan {
	int  aChan;
	MODE mode;
};


struct param_getbuf {
	int  aChan;
	int  capType;
	CAP_BUFFER cBuf;
};

struct param_relbuf {
	int aChan;
	int capType;
	int bufId;
};


struct param_cap {
	int  aChan;
	MODE mode;
};


struct param_startcap {
	int  aChan;
	MODE mode;
};


struct param_stopcap {
	int  aChan;
	MODE mode;
};


struct param_setvidmode {
	int  aChan;
	VIDEO_MODE mode;
};

struct param_setcapmode {
	int  aChan;
	CAPTURE_MODE mode;
};

struct param_getexterr {
	int dsp;
	int errChan;
	EXTERR exterr[SYS_EXTERR_BUF_SIZE];
};

struct param_getstatusinfo {
	int dsp;
	SYS_STATUS sysStat;
	int irq_count[16];
	int irq_tot;
};

struct param_setvidswitch {
	int switchOut[4];
};

struct param_setvidout {
	int outEn;
};

struct param_settime {
	int tm_sec;
	int tm_min;
	int tm_hour;
	int tm_mday;
	int tm_mon;
	int tm_year;
	int tm_wday;
	int tm_yday;
	int tm_isdst;
	int reserved[4];
};

struct param_setosdmode {
	int      aChan;
	OSD_MODE osdMode;
};

struct param_getdatamask {
	int      dm;
};

struct param_roundrobin {
	int dm;
	int aChan;
	int capType;
};

#endif
